from DHDL import subprogs
from DHDL import subprogs_xarray

def get1varUV(data,varname,args):

    #############################################################
    # check the dimension name    
    dimnameT,dimnameZ,dimnameY,dimnameX =subprogs.set_dim_name(data)
    #############################################################
    
    # get T slice (4-dim ->3-dim) with setting variable
    V3D,TTT,windU3D,windV3D = subprogs.get3D(args,dimnameT,data,varname)
    #############################################################
    
    #############################################################
    # get Z slice (3-dim -> 2-dim)
    V2D,ZZZ,windU2D,windV2D = subprogs.get2D(args,dimnameZ,data,\
                                             V3D,windU3D,windV3D)
    #############################################################
    
    #############################################################
    # to change unit (especially, for QR,QV, kg/kg -> g/kg)
    if varname == "QV" or varname == "QR": 
        V2D = V2D * 1000.0
        data[varname].attrs['units'] = "g/kg"
        #print(data[varname].units)
    #############################################################

    #############################################################
    # set colormap for shade and its range
    colormap, clevels = subprogs.set_color_range(args,V2D)
    #############################################################

    ######################################################################
    # calc max-min wind velocity to make reference vector size
    scaleUV,maxUV = subprogs.optimize_wind_vector_length(windU2D,windV2D)
    ######################################################################

    ######################################################################
    # data thin out for vector drawing
    if args.WINDTHIN is not None:
        if(int(args.WINDTHIN)==0):
            print("use must set WINDTHIN>1")
            exit(1)
        windU2D = subprogs_xarray.mabiki2D_xarray(windU2D,\
                                                  int(args.WINDTHIN))
        windV2D = subprogs_xarray.mabiki2D_xarray(windV2D,\
                                                  int(args.WINDTHIN))
    #############################################################

    return V2D,colormap,clevels,windU2D,windV2D,scaleUV,maxUV,TTT,ZZZ
